--[[(version 1.0)]]
local function tp ()
	if not game.player then log("Command/tp: player was nil?") return end 
	if not game.player.admin then game.player.print("Only Admins can use this command!") return end 
	
	if game.player.selected then
		local position = game.player.surface.find_non_colliding_position("player", game.player.selected.position, 10, 0.1)
		if not position then game.player.print("Fail: A position tot teleport to was not found.") return end 
		game.player.teleport(position) 
		game.player.print("Poof!")
	else 
		game.player.print("There was nothing selected!")
	end 	
end 
commands.remove_command("tp")
commands.add_command("tp", "Teleports you to the entity you select. [Admins]", tp)

--[[(version 1.0)]]
local function tp2me ()
	if not game.player then log("Command/tp2: player was nil?") return end 
	if not game.player.admin then game.player.print("Only Admins can use this command!") return end 
	
	if game.player.selected then
		local position = game.player.surface.find_non_colliding_position(game.player.selected.name, game.player.position, 10, 0.1)
		if not position then game.player.print("Fail: A position tot teleport to was not found.") return end 
		game.player.selected.teleport(position) 
		game.player.print("Poof!")
	else 
		game.player.print("There was nothing selected!")
	end 
end 
commands.remove_command("tp2me")
commands.add_command("tp2me", "Teleports the thing you have selected to you. [Admins]", tp2me)

--[[(version 1.0)]]
local function tp2spawn ()
	if not game.player then log("Command/tp2Spawn: player was nil?") return end 
	if not game.player.admin then game.player.print("Only Admins can use this command!") return end 

	game.player.teleport(game.player.force.get_spawn_position(game.player.surface))
	game.player.print("Poof!")
end 
commands.remove_command("tp2spawn")
commands.add_command("tp2spawn", "Teleports you to the exact position of spawn. [Admins]", tp2spawn)

--[[(version 1.0)]]
local function nameOfItem ()
	if not game.player then log("Command/nameOfItem: player was nil?") return end 
	if game.player.cursor_stack.valid_for_read then
		game.player.print("Cursor item name: \"" .. game.player.cursor_stack.name .. "\".")
		game.player.print("Cursor item subgroup: \"" .. game.player.cursor_stack.prototype.subgroup.name .."\", order: \"" .. game.player.cursor_stack.prototype.order .. "\"." )
	else 
		game.player.print("Cursor is empty.")
	end 

	if game.player.selected then
		game.player.print("Selected thing's name: \"" .. game.player.selected.name .. "\".")
		game.player.print("Selected thing's type: \"" .. game.player.selected.type .. "\".")
	else 
		game.player.print("There was nothing selected.")
	end 
end 
commands.remove_command("namethis")
commands.add_command("namethis", "Prints information about the item on your cursor and/or the thing you have selected. [Anyone]", nameOfItem)

--[[(version 1.1)]]
local function gameSpeed(event)	
	local trustedGroup = "Trusted (Deco&ArtyRemote)"	
	local speedLowerBound = 0.1
	local speedUpperBound = 1

	if not game.player then log("Command/gameSpeed: player was nil?") return end 
	local inputString = event["parameter"]
	
	if not inputString then 
		game.player.print("The game speed is currently set to: " .. game.speed .. " this means " .. (60 * game.speed) .. " UPS.")
		if game.player.permission_group.name == trustedGroup or game.player.admin then
			game.player.print("To change the speed supply a value from " .. speedLowerBound .. " to " .. speedUpperBound .. ".") 	
		end 
		return 
	end 

	log("Command/gameSpeed: ".. game.player.name .. " entered \"" .. inputString .. "\" for the new speed.")

	if not game.player.permission_group.name == trustedGroup and not game.player.admin then game.player.print("Onely Trusted people can change the game speed!") return end 	

	local newSpeed = tonumber(inputString)
	if not newSpeed then game.player.print(inputString .. " could not be converted into a number!") return end 
	if newSpeed >= 9000 then game.player.print("The Server's Power Level can't handle that kind of Speed!") return end 
	if newSpeed > speedUpperBound then game.player.print("You may not set the GameSpeed to above " .. speedUpperBound .. ".") return end 
	if newSpeed <= 0 then game.player.print("Don't try to crash the Server! Setting GameSpeed to zero or in the negatives makes no sense!") return end 
	if newSpeed < speedLowerBound then game.player.print("You can't set the GameSpeed to below " .. speedLowerBound .. ": it is too slow!") return end 

	log("Command/gameSpeed: We will apply " .. newSpeed .. " as the new gameSpeed.")
	game.speed = newSpeed
	game.print(game.player.name .. " set the game speed to " .. newSpeed)
end 

commands.remove_command("gamespeed")
commands.add_command("gamespeed", "Show the current GameSpeed [Anyone], or change the game speed [Trusted players]. Valid parameters range from 0.1 to 1", gameSpeed)

